' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2010                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVIL Sample Program
' C_CAO
'
' 쐬 : N.Moriguchi
'
'  : 2011/03/01 
'
' Binarize Blob Sample Program
' -----------------------------------------------------------------
Public Class Form_BINARIZE_BLOB_SAMPLE

    Private m_image As FVIL.Data.CFviImage = New FVIL.Data.CFviImage()          '摜i[̈
    Private m_imagebin As FVIL.Data.CFviImage = New FVIL.Data.CFviImage()       'Ql摜i[̈
    Private m_video As FVIL.Video.CFviVideo                                     'rfI̓NX
    Private m_timer As FVIL.CFviTimeCounter = New FVIL.CFviTimeCounter()        'ԌvNX
    Private m_overlay As FVIL.GDI.CFviOverlay = New FVIL.GDI.CFviOverlay()      '\I[o[CNX錾

    Dim intErr As Integer                                                       'G[ԍi[ϐ
    Public m_strIniFilePath As String                                           'init@CitpXj

    Private m_flgVideoOpened As Boolean                                         'rfIfoCX̃I[v

    Private Sub FormMainLoad(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'FVIL̏
        'AvP[VNA ̊֐ĂяoăCuĂB 
        '̎ACZX̔F؂s܂BpԒłĂȀ͕KsKvL܂B 
        'sȂꍇ́AveNgꂽNX̎sł܂B
        FVIL._SetUp.InitVisionLibrary()

        'ԕϐ̏
        m_flgVideoOpened = False

        'vԃeLXg{bNX
        TextBoxTime.Text = "0"

        'gK[hR{{bNX
        ComboBoxTrigger.Items.Clear()
        ComboBoxTrigger.Items.Add("m[}")
        ComboBoxTrigger.Items.Add("gK")
        ComboBoxTrigger.Items.Add("OgK")
        ComboBoxTrigger.SelectedIndex = 0

        'J[[hR{{bNX
        ComboBoxColorMode.Items.Add("OiF^wiF")      'BlackFG_WhiteBG
        ComboBoxColorMode.Items.Add("OiF^wiF")      'WhiteFG_BlackBG
        ComboBoxColorMode.Items.Add("OiF^wiF")      'BlackFG
        ComboBoxColorMode.Items.Add("OiF^wiF")      'WhiteFG
        ComboBoxColorMode.SelectedIndex = FVIL.Blob.ObjectColor.BlackFG_WhiteBG

    End Sub

    ''' <summary>
    ''' tH[\Jn Cxgnh
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' gpmF܂B
    ''' </remarks>
    Private Sub formMain_Shown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Shown
        'gp̊mF
        Dim licence_dialog As New dialogLicence
        If (licence_dialog.ShowDialog(Me) <> Windows.Forms.DialogResult.OK) Then
            Me.Close() 'gpȂꍇ̓TvvO̓I
            Exit Sub
        End If

        'init@CI
        fnSetIniFile()
        '`imagẽZbg
        CFviImageView1.Image = Me.m_image
        'I[o[C̒ǉ
        CFviImageView1.Display.Overlays.Add(m_overlay)

    End Sub

    ''' <summary>
    ''' I
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' AvP[VIB
    ''' </remarks>
    Private Sub FormMainFormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        'rfIfoCXI[vĂꍇ̓N[Y
        If (m_flgVideoOpened = True) Then
            m_video.Close()
            m_flgVideoOpened = False
        End If

    End Sub

    ''' <summary>
    ''' init@CI֐
    ''' </summary>
    ''' <remarks>
    ''' init@C̑I܂B
    ''' </remarks>
    Private Sub fnSetIniFile()
        Dim formbroseini As New Form_BROWSEINI  'init@Cݒ

        'init@C̑I
        m_strIniFilePath = ""
        If (Form_BROWSEINI.ShowDialog(Me) = Windows.Forms.DialogResult.OK) Then
            m_strIniFilePath = Form_BROWSEINI.strIniFilePath
        End If

        If (m_strIniFilePath.Length > 0) Then
            Try
                'ݒt@C̃[hƃfoCXI[v
                m_video = FVIL.Video.Function.CreateInstance(m_strIniFilePath)
                m_flgVideoOpened = True

                'Xe[^X\̍XV
                'gK[h̎擾
                ComboBoxTrigger.SelectedIndex = m_video.Trigger
                'JIԂ̎擾
                If (m_video.DeviceType <> FVIL.Video.DeviceType.RICE001) Then
                    NumericUpDownExposure.Enabled = True
                    NumericUpDownExposure.Value = m_video.ExposureTime
                Else
                    NumericUpDownExposure.Enabled = False
                End If
                ButtonGrabOne.Enabled = True
            Catch ex As FVIL.CFviException
                'G[
                MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Catch ex As Exception
                'G[
                MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        ElseIf (Form_BROWSEINI.UseFileFlg = True) Then
            't@Cgp
            ButtonGrabOne.Enabled = False
        Else
            'init@CȈꍇ̓TvvO̓I
            Me.Close()
            Exit Sub
        End If

    End Sub

    ''' <summary>
    ''' Grab One{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' J荞݁B
    ''' </remarks>
    Private Sub ButtonGrabOne_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGrabOne.Click
        Dim msec As Double = 0
        Try
            'I[o[CNA
            m_overlay.Figures.Clear()

            'foCX^Cv
            Select Case m_video.DeviceType
                Case FVIL.Video.DeviceType.FVC05, FVIL.Video.DeviceType.FVC06, FVIL.Video.DeviceType.FVC07, FVIL.Video.DeviceType.FV1300, FVIL.Video.DeviceType.GP440, FVIL.Video.DeviceType.RICE001
                    '摜TCY
                    m_video.ChangeImageSize(m_image)
                    'ԑJn
                    m_timer.Start()
                    'J荞
                    m_video.GrabImageSync(m_image)
                    'ԑI
                    msec = m_timer.Stop()
                Case FVIL.Video.DeviceType.FHC3312
                    Dim video As FVIL.Video.CFviVideoFHC3312 = DirectCast(m_video, FVIL.Video.CFviVideoFHC3312)
                    Dim contgrab As FVIL.Video.CFviContinuousGrabFHC3312 = video.ContinuousGrab
                    '摜TCY
                    video.ChangeImageSize(m_image)
                    'bN
                    contgrab.MemoryLock(m_image)
                    'ԑJn
                    m_timer.Start()
                    'J荞
                    contgrab.GrabSync(1)
                    'ԑI
                    msec = m_timer.Stop()
                Case FVIL.Video.DeviceType.FHC3313
                    Dim video As FVIL.Video.CFviVideoFHC3313 = DirectCast(m_video, FVIL.Video.CFviVideoFHC3313)
                    Dim contgrab As FVIL.Video.CFviContinuousGrabFHC3313 = video.ContinuousGrab
                    '摜TCY
                    video.ChangeImageSize(m_image)
                    'bN
                    contgrab.MemoryLock(m_image)
                    'ԑJn
                    m_timer.Start()
                    'J荞
                    contgrab.GrabSync(1)
                    'ԑI
                    msec = m_timer.Stop()


                    '' add Start
                    ''摜TCY
                    'video.ChangeImageSize(m_image)
                    ''ԑJn
                    'm_timer.Start()
                    ''J荞
                    'm_video.GrabImageSync(m_image)
                    ''ԑI
                    'msec = m_timer.Stop()
                    ''add end

            End Select
            TextBoxTime.Text = msec.ToString("0.000")   '莞ԕ\
            Form_BROWSEINI.UseFileFlg = False
            '荞񂾉摜2l܂B
            fnBinarize()
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Load File {^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' Ώۉ摜ǂݍ݂܂B
    ''' </remarks>
    Private Sub ButtonLoadFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonLoadFile.Click
        Dim ofdlg As OpenFileDialog = New OpenFileDialog()

        ofdlg.Filter = "摜t@C(*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat)|*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat"
        ofdlg.Filter += "|Bitmap t@C (*.bmp;*.dib)|*.bmp;*.dib"
        ofdlg.Filter += "|Png t@C (*.png)|*.png"
        ofdlg.Filter += "|Jpeg t@C (*.jpg;*.jpeg)|*.jpg;*.jpeg"
        ofdlg.Filter += "|Tiff t@C (*.tif;*.tiff)|*.tif;*.tiff"
        ofdlg.Filter += "|Raw t@C (*.raw)|*.raw"
        ofdlg.Filter += "|ׂẴt@C (*.*)|*.*"

        If (ofdlg.ShowDialog(Me) = DialogResult.OK) Then
            ''
            '' 摜t@Cǂݍ
            ''
            Try
                '̊֐́AȈՓIɉ摜t@C̃[hŝׂ̂łB 
                '̊֐ŎwłȂp[^w肷Kv΁A e摜t@CANZXNX𒼐ڎgpĂB 
                FVIL.File.Function.LoadImageFile(ofdlg.FileName, m_image, FVIL.PixelMode.Unpacking)

                'ǂݍ񂾉摜2l܂B
                fnBinarize()

                'ǂݍރt@C`Œ̏ꍇ́Aȉ̂悤ɋLq܂B
                '1) bmpt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileBmp = New FVIL.File.CFviImageFileBmp()
                'file.Load(ofdlg.FileName, m_image)

                '2) jpgt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileJpg = New FVIL.File.CFviImageFileJpg()
                'file.Load(ofdlg.FileName, m_image)

            Catch ex As FVIL.CFviException
                Dim warning As String = String.Format(" : code={0} func={1}", ex.ErrorCode, ex.Function)
                MessageBox.Show(warning, "t@Cǂݍ݂ŃG[܂B", MessageBoxButtons.OK, MessageBoxIcon.Warning)
            Catch ex As System.NotSupportedException
                Dim warning As String = ex.Message
                MessageBox.Show(warning, "t@Cǂݍ݂ŃG[܂B", MessageBoxButtons.OK, MessageBoxIcon.Warning)
            End Try
        End If

    End Sub

    ''' <summary>
    ''' s{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' Qlvs܂B
    ''' </remarks>
    Private Sub ButtonExecute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonExecute.Click
        m_overlay.Figures.Clear()           'I[o[CNA
        Me.ListView.Items.Clear()           'Xgr[NA

        Try
            'QlvNX̃IuWFNg쐬
            Dim blob As FVIL.Blob.CFviBlob = New FVIL.Blob.CFviBlob()

            ' Ώۉ摜̗L
            ' CheckValidity()͈Ɏw肳ꂽ摜IuWFNg\ۂ𔻒肵܂
            ' 摜IuWFNg\łiŒłjꍇȂǂ͕Kv܂B
            intErr = FVIL.Blob.CFviBlob.CheckValidity(m_imagebin)
            If (intErr <> FVIL.ErrorCode._SUCCESS) Then
                MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Exit Sub
            End If

            blob.SrcImages(0) = m_imagebin  '͉摜̐ݒ

            'p[^ݒ
            'J[[hݒ
            Select Case ComboBoxColorMode.SelectedIndex
                Case FVIL.Blob.ObjectColor.BlackFG_WhiteBG
                    blob.Param.ColorMode = FVIL.Blob.ObjectColor.BlackFG_WhiteBG    'OiF^wiF
                Case FVIL.Blob.ObjectColor.WhiteFG_BlackBG
                    blob.Param.ColorMode = FVIL.Blob.ObjectColor.WhiteFG_BlackBG    'OiF^wiF
                Case FVIL.Blob.ObjectColor.BlackFG
                    blob.Param.ColorMode = FVIL.Blob.ObjectColor.BlackFG            'OiF^wiF
                Case FVIL.Blob.ObjectColor.WhiteFG
                    blob.Param.ColorMode = FVIL.Blob.ObjectColor.WhiteFG            'OiF^wiF
            End Select
            'Aݒ
            If (RadioButtonNeighborhood8.Checked) Then
                blob.Param.Neighborhood = FVIL.Blob.Neighborhood.Eight          'AFWߖT
            Else
                blob.Param.Neighborhood = FVIL.Blob.Neighborhood.Four           'AFSߖT
            End If

            'Qlʌvs
            blob.Execute()

            'ʎ擾tB^z𐶐
            Dim filters As List(Of FVIL.Blob.CFviBlobFilterRange) = New List(Of FVIL.Blob.CFviBlobFilterRange)()

            filters.Add(New FVIL.Blob.CFviBlobFilterRange())    'tB^֒ǉ
            filters(0).Type = FVIL.Blob.FeatureType.AREA        'ʐϒltB^֒ǉ
            filters(0).Max = NumericUpDownFilterMax.Value       'ʐϏl
            filters(0).Min = NumericUpDownFilterMin.Value       'ʐωl

            'u[uf[^z̎擾
            Dim datas As List(Of FVIL.Blob.CFviBlobData) = New List(Of FVIL.Blob.CFviBlobData)()
            datas = blob.Result.GetList(filters)                'ʐϒl͈͓BLOBzɊi[

            '擾̏I[o[C֕`
            Dim i As Integer
            For i = 0 To (datas.Count - 1) Step 1
                Dim center As FVIL.Data.CFviPoint = New FVIL.Data.CFviPoint                         '_f[^^
                center = datas(i).Center                                                            'dS擾
                Dim ellipse As FVIL.Data.CFviEllipse = New FVIL.Data.CFviEllipse                    'ȉ~f[^^
                ellipse = datas(i).EquivalentEllipse                                                'ȉ~擾
                Dim strBlobNo As System.String                                                      'f[^^
                strBlobNo = System.String.Format("{0}", i)                                          'u[uԍ擾

                Dim ol_center As FVIL.GDI.CFviGdiPoint = New FVIL.GDI.CFviGdiPoint(center)          '`p_f[^
                ol_center.Size = New Size(5, 5)                                                     '`TCYݒ
                ol_center.Pen.Color = Color.FromArgb(255, 0, 0)                                     '`Fݒ

                Dim ol_ellipse As FVIL.GDI.CFviGdiEllipse = New FVIL.GDI.CFviGdiEllipse(ellipse)    '`pȉ~f[^
                ol_ellipse.Pen.Color = Color.FromArgb(0, 0, 255)                                    '`Fݒ

                Dim ol_blobno As FVIL.GDI.CFviGdiString = New FVIL.GDI.CFviGdiString()              '`pf[^
                ol_blobno.Text = String.Format("{0}", strBlobNo)                                    'ݒ
                ol_blobno.Position = center                                                         '`ʒuݒ
                ol_blobno.Color = Color.FromArgb(0, 255, 0)                                         '`Fݒ

                'I[o[C֒ǉ
                m_overlay.Figures.Add(ol_center)
                m_overlay.Figures.Add(ol_ellipse)
                m_overlay.Figures.Add(ol_blobno)

                'Xgr[ɒǉ
                Dim item As ListViewItem = New ListViewItem(i.ToString())
                Me.ListView.Items.Add(item)
                item.SubItems.Add(New ListViewItem.ListViewSubItem(item, datas(i).Area.ToString()))
                item.SubItems.Add(New ListViewItem.ListViewSubItem(item, datas(i).Center.X.ToString("0.00")))
                item.SubItems.Add(New ListViewItem.ListViewSubItem(item, datas(i).Center.Y.ToString("0.00")))
            Next

            'I[o[C`
            m_overlay.Enable = True
            'r[̍XV
            CFviImageView1.Refresh()
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' ŒQls֐
    ''' </summary>
    ''' <remarks>
    ''' ŒQls܂B
    ''' </remarks>
    Private Sub fnBinarize()
        Try
            'ŒQlNX錾
            Dim parser As FVIL.Conversion.CFviBinarize = New FVIL.Conversion.CFviBinarize()

            ' Ώۉ摜̗L
            ' CheckValidity()͈Ɏw肳ꂽ摜IuWFNg\ۂ𔻒肵܂
            ' 摜IuWFNg\łiŒłjꍇȂǂ͕Kv܂B
            intErr = FVIL.Conversion.CFviBinarize.CheckValidity(m_image)
            If (intErr <> FVIL.ErrorCode._SUCCESS) Then
                MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Exit Sub
            End If

            '摜
            parser.SrcImages(0) = m_image       '͉摜Zbg
            parser.DstImages(0) = m_imagebin    'o͉摜Zbg

            'IsValid()́AΏۉ摜Lȏꍇ true Ԃ܂B 
            'ȏꍇ false Ԃ܂B 
            '̏ꍇ FVIL.CFviObject.ErrorCode G[̏ڍ׏擾ł܂B 
            'Lȏꍇ ErrorCode  FVIL.ErrorCode._SUCCESS ɐݒ肳Ă܂
            If (Not parser.IsValid()) Then   ' L.
                'Validate()o͉摜L鎖ł܂B 
                '̃\bhsƁAo͉摜̗̈TCYA摜ʁA`lK؂Ȃ̂ɐݒ肵܂B
                'AAo͉摜Ă܂̂ŁAgpۂɂ́AӂB
                parser.Validate()
            End If

            'p[^ݒ
            parser.Threshold = NumericUpDownThreshold.Value    'lݒ

            '摜s
            parser.Execute()
            '2l摜CFvImageViewɕ\܂B
            CFviImageView1.Image = m_imagebin   '`Ώۂ̉摜IuWFNgZbg
            CFviImageView1.Refresh()            'ĕ`
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' ͈͐ݒ{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 摜̗̈ݒ肵܂B
    ''' </remarks>
    Private Sub ButtonProcessSetArea_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonProcessSetArea.Click
        If (CFviImageView1.GetOverlayActive(FVIL.GDI.CFviDrawProcarea.OverlayID)) Then
            CFviImageView1.SetOverlayActive(FVIL.GDI.CFviDrawProcarea.OverlayID, False)
        Else
            '͈͑I[hɕύX
            CFviImageView1.SetOverlayActive(FVIL.GDI.CFviDrawProcarea.OverlayID, True)
        End If
        'ĕ`
        CFviImageView1.Refresh()

    End Sub

    ''' <summary>
    ''' Save Image{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' \摜ۑ
    ''' </remarks>
    Private Sub ButtonSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSaveImage.Click
        Dim ofdlg As SaveFileDialog = New SaveFileDialog()
        ofdlg.Filter = "摜t@C(*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat)|*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat"
        ofdlg.Filter += "|Bitmap t@C (*.bmp;*.dib)|*.bmp;*.dib"
        ofdlg.Filter += "|Png t@C (*.png)|*.png"
        ofdlg.Filter += "|Jpeg t@C (*.jpg;*.jpeg)|*.jpg;*.jpeg"
        ofdlg.Filter += "|Tiff t@C (*.tif;*.tiff)|*.tif;*.tiff"
        ofdlg.Filter += "|Raw t@C (*.raw)|*.raw"
        ofdlg.Filter += "|ׂẴt@C (*.*)|*.*"
        ofdlg.OverwritePrompt = True

        If (ofdlg.ShowDialog(Me) = Windows.Forms.DialogResult.OK) Then
            Try
                '̊֐́AȈՓIɉ摜t@C̕ۑŝׂ̂łB 
                '̊֐ŎwłȂp[^w肷Kv΁A e摜t@CANZXNX𒼐ڎgpĂB 
                FVIL.File.Function.SaveImageFile(ofdlg.FileName, CFviImageView1.Image)

                'ۑt@C`Œ̏ꍇ́Aȉ̂悤ɋLq܂B
                '1) bmpt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileBmp = New FVIL.File.CFviImageFileBmp()
                'file.Save(ofdlg.FileName, m_image)

                '2) jpgt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileJpg = New FVIL.File.CFviImageFileJpg()
                'file.Save(ofdlg.FileName, m_image)

            Catch ex As FVIL.CFviException
                Dim msg As System.String = System.String.Format("CuO𔭍s܂Bcode={0} func={1}", ex.ErrorCode, ex.Function)
                Select Case (ex.ErrorCode)
                    Case FVIL.ErrorCode.NOT_SUPPORTED, _
                     FVIL.ErrorCode.INVALID_OBJECT
                        msg += vbCrLf + "T|[gĂȂ摜IuWFNgłB"
                        msg += vbCrLf + "Raw `ŕۑĂB"
                End Select
                MessageBox.Show(msg, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Catch ex As Exception
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        End If

    End Sub

    ''' <summary>
    ''' Xg̃NbNɉĕ\ύX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' Xg̃ACeւ̃NbNɉăI[oC̕\ύXB
    ''' </remarks>
    Private Sub ListView_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListView.SelectedIndexChanged
        Dim index As Integer = 0
        Dim InfoGroup As Integer = 3                            'uuPӂ̕\

        'IXĝ݃I[o[C\AXgȊOIꍇSI[o[C\B
        For i As Integer = 0 To (ListView.Items.Count - 1) Step 1
            Dim item As ListViewItem = ListView.Items(i)
            Dim bEnable As Boolean

            'XgI
            If (ListView.SelectedItems.Count > 0) Then
                bEnable = (item.Checked Or item.Selected)       'IACȅꍇTRUEݒ肵AȊOFALSEݒ肷
            Else
                bEnable = True                                  'XgȊOIꍇSTRUEݒ肷
            End If

            m_overlay.Figures(index).Enable = bEnable           'dSʒu\i\jɂ
            m_overlay.Figures(index + 1).Enable = bEnable       'ȉ~\i\jɂ
            m_overlay.Figures(index + 2).Enable = bEnable       'u[uԍ\i\jɂ
            index += InfoGroup
        Next

        'ĕ`
        CFviImageView1.Refresh()

    End Sub

    ''' <summary>
    ''' Trigger ModeR{{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' m[}[hEgK[hEOgK[h̑IB
    ''' </remarks>
    Private Sub ComboBoxTrigger_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxTrigger.SelectedIndexChanged, ComboBoxTrigger.SelectedIndexChanged
        Try
            If (m_flgVideoOpened = True) Then
                m_video.Trigger = ComboBoxTrigger.SelectedIndex
                'ЃLv`{[h̓gK[[h̐ݒɃZbgAbv^CKvɂȂ܂
                '{vÕZbgAbv^C͕Kvőlł350msݒ肵Ă܂B
                'Lv`{[hɂĂ̎Ԃ͈قȂ܂B
                Threading.Thread.Sleep(350)
            End If
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' Exposure NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' JIԂ̐ݒB
    ''' </remarks>
    Private Sub ExposureValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownExposure.ValueChanged, NumericUpDownExposure.ValueChanged
        Try
            If (m_flgVideoOpened = True) Then
                m_video.ExposureTime = NumericUpDownExposure.Value
            End If
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Threshold NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 2ll̐ݒ
    ''' </remarks>
    Private Sub NumericUpDownThreshold_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownThreshold.ValueChanged
        'ŒQls܂B
        fnBinarize()

    End Sub

    ''' <summary>
    ''' x1{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' {ŕ\܂B
    ''' </remarks>
    Private Sub ButtonMag1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMag1.Click
        '摜̕\{̎擾܂͐ݒs܂B1.0Ǝw肷Ɠ{ŕ\܂B
        '{ĺA0.5Ƃꍇ́AE1/2ƂȂAʐς1/4ɂȂ܂B
        '3.0Ƃꍇ́AE3{ƂȂAʐς9{ɂȂ܂B
        CFviImageView1.Display.Magnification = 1.0      '\{̐ݒ
        CFviImageView1.Refresh()                        'ĕ`

    End Sub

    ''' <summary>
    ''' Fit{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 摜Ŝr[̃NCAg̈ɕ\ł悤ɕ\{k(܂͊g)܂
    ''' </remarks>
    Private Sub ButtonFit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonFit.Click
        '摜Ŝr[̃NCAg̈ɕ\ł悤ɕ\{k(܂͊g)܂
        CFviImageView1.FitImageSize()                   '\{𒲐
        CFviImageView1.Refresh()                        'ĕ`

    End Sub

    ''' <summary>
    ''' {{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ݂̔{0.5{ŕ\܂B
    ''' </remarks>
    Private Sub ButtonPlus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonPlus.Click
        Dim Value As Double
        Value = CFviImageView1.Display.Magnification    '{̎擾
        Value = Value + 0.5
        CFviImageView1.Display.Magnification = Value    '\{̐ݒ
        CFviImageView1.Refresh()                        'ĕ`

    End Sub

    ''' <summary>
    ''' |{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ݂̔{0.5{ŕ\܂BA{OȉɂȂꍇ͔{0.1ŕ\܂B
    ''' </remarks>
    Private Sub ButtonMinus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMinus.Click
        Dim Value As Double
        Value = CFviImageView1.Display.Magnification    '{̎擾
        Value = Value - 0.5
        If (Value <= 0) Then
            Value = 0.1       'Oȉݒ肷ƃG[ɂȂ̂0.1ݒ肷
        End If
        CFviImageView1.Display.Magnification = Value    '\{̐ݒ
        CFviImageView1.Refresh()                        'ĕ`

    End Sub

    ''' <summary>
    ''' Ascope`FbN{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ASCOPE̕\ؑւ܂B
    ''' </remarks>
    Private Sub CheckBoxAScope_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxAscope.CheckedChanged
        'ASCOPEI[oC̐ݒ
        If (CheckBoxAscope.CheckState) Then
            'ASCOPE̕\LɂB
            CFviImageView1.Display.OverlayAscope.Enable = True
            CFviImageView1.Display.OverlayAscope.Active = True
        Else
            'ASCOPE̕\𖳌ɂB
            CFviImageView1.Display.OverlayAscope.Enable = False
            CFviImageView1.Display.OverlayAscope.Active = False
        End If
        CFviImageView1.Refresh()                        'ĕ`

    End Sub

End Class
